Subject: bug#46256: closed (Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 28 Feb 2021 21:05:02 +0000

Your bug report

#46256: [feature/native-comp] AOT eln files ignored if run from build tree

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
46256: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=46256
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#46256: [feature/native-comp] AOT eln files ignored if run from build tree
From: Andrea Corallo <[email-masked]>
To: Andy Moreton <[email-masked]>
Cc: [email-masked]
Date: Sun, 28 Feb 2021 21:04:43 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Andy Moreton <[email-masked]> writes:

> On Sat 27 Feb 2021, Andy Moreton wrote:
>
>> On Sat 27 Feb 2021, Andrea Corallo via "Bug reports for GNU Emacs, the Swiss army knife of text editors" wrote:
>>
>>> Andy Moreton <[email-masked]> writes:
>>>> There are still some elisp files that did not get native compiled when
>>>> the build was done with "make -j8 NATIVE_FULL_AOT=1", and so get async
>>>> compiled when running the built emacs:
>>>>
>>>>   ansi-color auth_source byte-opt bytecomp cconv cl-extra cl-lib cl-macs
>>>>   cl-seq comint comp comp-cstr cus-edit cus-start desktop
>>>>   display-fill-column-indicator easy-mmode easymenu edmacro eieio
>>>>   eieio-core frameset gv help-mode hl-line image-file info json kmacro
>>>>   map minibuf-eldef package paren password-cache pcase pp ring rx seq
>>>>   subr-x time-date warnings wid-edit
>>>>
>>>> That may be a result of the error during the build.
>>>
>>> Mmmmh, that's strange some of these are even compiled as COMPILE_FIRST
>>> therfore are certainly native compiled.
>>
>> I suspect that the issue may be with parallel builds (note the "-j8"
>> above). Repeating the build with "-j1" appears to be building the
>> missing .eln files as expected.
>
> Now that the -j1 build has completed (without error), all of the lisp
> files have been compiled AOT as expected, and running the resulting
> emacs does not rebuild any of those .eln files.
>
> So I think there are still some other issues with dependencies and
> handling parallel builds, but this bug has been fixed.

Thanks for checking, I'm closing then.

  Andrea

Subject: [feature/native-comp] AOT eln files ignored if run from build tree
From: Andy Moreton <[email-masked]>
To: [email-masked]
Date: Tue, 2 Feb 2021 11:11:08 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi,

I have built emacs native-comp branch for 64bit Mingw64 with
NATIVE_FULL_AOT=1 (out of tree, so build dir != source dir).

I notice that if I run the built emacs from the build dir then the
prebuilt .eln files are ignored, and async compilation of the .eln file
happens again to add them to the user eln-cache dir.

The prebuilt .eln files are not found in the user eln-cache (expected)
or the installed emacs directory (also expected), but it looks like it
does not also check the build dir (relative to the running emacs rather
than relative to the install prefix).

Running from the build dir without installing is common for developers
building from source, so it would be useful to keep this working with
native AOT builds.

     AndyM